local tz = 3
local key = "XXXXXXXXXXXXXX" -- !!!!!!!
local city = "Moscow" --!!!!!!
print('city:'..city)

local cnt = '6'
local _conn, stop_stream, data_received, cb_disconnected
local _skip_headers = true
local _chunk = ""
local frame = "T15"
local gotcode = false
local code, tempavg, request, killask

local tm = rtctime.epoch2cal(rtctime.get())
local hour = tm["hour"] + tz
print('\n\t\t\thour now:', hour) 

if hour >= 15 and hour < 21 then frame = "T03" end

stop_stream = function(c)
  if killask then killask:stop(); killask:unregister(); killask = nil end
  if _conn then
    pcall(function() _conn:close() end)
    _conn = nil
  end
  c = nil
end

data_received = function(c, data)
  if _skip_headers then
    _chunk = _chunk..data
    local i, j = string.find(_chunk, frame)
    if i then
      _skip_headers = false
      data = string.sub(_chunk, j+1, -1)
      _chunk = data
    else
      _chunk = ""
    end
  end

  if not _skip_headers then
    if gotcode then _chunk = _chunk..data end
    code = string.match(_chunk, ':00"><symbol number="(%d+)' )
    tempavg = string.match(_chunk, 's" value="(%p*%d+%p*%d*)' )
    -- local sky = string.match(data, 'ds value="(%a+%s*%a*)' )
    if code and tempavg then
      print('\n\t\t\tGot Data to Time'..frame..':00')
      print('\t\t\tGot Code:', code, tempavg)
      -- print('\t\t\tSky:', sky)
      wth.codef = tonumber(code)
      -- wth.maintemp = tonumber(tempavg)
      wth.avgtf = tempavg
      stop_stream(c)
    else
        gotcode = true
    end
  end
end

cb_disconnected = function()
  print("Disconnected")
end

request = "GET http://api.openweathermap.org/data/2.5/forecast?q="..city.."&mode=xml&units=metric&cnt="..cnt.."&appid="..key.." HTTP/1.1\r\n" ..
"Host: api.openweathermap.org\r\n"


if wifi.sta.status() == 5 then
  net.dns.resolve("api.openweathermap.org", function(sk, ip)
      if (ip == nil) then
          print("Lost DNS openweathermap!")
      else
          killask = tmr.create()
          killask:alarm(2000, 0, function(_)
              if _conn then
                stop_stream(_conn)
                  print('\n\nConn killed!\n\n')
              end
          end)

          _conn = net.createConnection(net.TCP, 0)
          _conn:on("connection", function(conn, payload) conn:send(request.."Connection: close\r\nAccept: /\r\n\r\n") end)
          _conn:on("receive", data_received)
          _conn:on("disconnection", cb_disconnected)
          _conn:connect(80, 'api.openweathermap.org')          

      end
  end)
end
