do
    -- rtctime.set(0)
    timetb = function (t, sec)
        if not t or type(t) ~= 'table' then t = {} end
        if not sec or type(sec) ~= 'number' then sec = 600 end
        local _t = t
        t = {}
        local mt = {
            __newindex = function (t, k, v)
                local tm = (rtctime.get())
                local ecdat 
                if _t[k] then
                    if _t[k][1] then
                        ecdat = _t[k][1]
                    end
                end
                if not ecdat or ecdat ~= v then
                    _t[k] = {v, tm}
                end
            end,
            __index = function(t, k)
                if not _t[k] then return nil end
                if (rtctime.get()) - _t[k][2] < sec then
                    return _t[k][1]
               end
            end,
        }
        setmetatable(t, mt)
        return t
    end
    return timetb()
end